/************************************************************
*        PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq        *
*   "Desenvolvimento de uma arquitetura para simulao do   *
*      Funcionamento distribudo e paralelo do crebro"     *
* --------------------------------------------------------- *
*      BOLSISTA: Anderson de Rezende Rocha - DCC/UFLA       *
*       ORIENTADOR: Antnio Maria Pereira de Resende        *
************************************************************/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

// Tratador de eventos do configurador do agente centralizador
public class HandlerConfigAgente implements ActionListener
{
   Component componentePai;
   String entrada = "";
   ConfigAgente config;

   // Ponteiros para os componentes pai
   HandlerConfigAgente(Component cpt, ConfigAgente ca)
   {
      componentePai = cpt;
      config = ca;
   }

   // Identificao do tipo de ao impetrada pelo usurio
   public void actionPerformed(ActionEvent e)
   {
      if (e.getSource() == config.setupCompleto)
      {
         config.dispose();
      }
      else if (e.getSource() ==  config.tempoEspera)
      {
         long tempo;
         try
         {
            tempo = (Long.parseLong(e.getActionCommand()));
            config.setTempoEspera(tempo);
            config.tempoEspera.setEnabled(false);
            config.numeroObstaculos.setEnabled(true);
            config.status.setText("Agora configure os obstculos");
         }
         catch (NumberFormatException nfe)
         {
            JOptionPane.showMessageDialog(componentePai, "Tempo invlido. Tempo padro escolhido", 
                                         "Aviso", JOptionPane.WARNING_MESSAGE);
            config.setTempoEspera(250);
            config.tempoEspera.setEnabled(false);
            config.status.setText("Agora configure os obstculos");
         }
      }
      else if (e.getSource() == config.numeroRobots)
      {
         try
         {
            int nroRobots = Integer.parseInt(e.getActionCommand());
            config.setNumeroRobots(nroRobots);
            lerDados(nroRobots, 1);
            config.numeroRobots.setEnabled(false);
            config.tempoEspera.setEnabled(true);
            config.status.setText("Tempo de movimentao dos ROBOTs");
         }
         catch (NumberFormatException nfe)
         {
            config.setNumeroRobots(2);
            config.numeroRobots.setEnabled(false);
            config.tempoEspera.setEnabled(true);
            config.status.setText("Tempo de movimentao dos ROBOTs");
            JOptionPane.showMessageDialog(componentePai, "Digite um numero de ROBOTs vlido" + 
                                          "\nNmero padro de robots selecionado",
                                          "Aviso", JOptionPane.WARNING_MESSAGE);
         }
      }
      else if (e.getSource() == config.numeroObstaculos)
      {
         try
         {
            int nroObstaculos = Integer.parseInt(e.getActionCommand());         	
            lerDados(nroObstaculos, 2);
            config.numeroObstaculos.setEnabled(false);
            config.setupCompleto.setEnabled(true);
            config.status.setText("Pronto! Clique em Retornar");
         }
         catch (NumberFormatException nfe)
         {
               JOptionPane.showMessageDialog(componentePai, "Digite dados vlidos do tipo x,y",  
                                          "Aviso", JOptionPane.WARNING_MESSAGE);
         }
      }
   }

   private int getLimite()
   {
      return config.getLimite();
   }
   
   public void lerDados(int limite, int chave)
   {
      String pNumero = "", sNumero = "";
      String entrada;
      char tmp;
      boolean primeiro = true;
      int pontoX, pontoY;

      for (int i = 1; i <= limite; i++)
      {
         try
         {
            if (chave == 1)
               entrada = JOptionPane.showInputDialog(componentePai, "Entre com a posio inicial do ROBOT " + i +
                                         "\nClique OK para confirmar\n" + "Ex.: 2,3 quer dizer [x=2, y=3]\n" +         "\nNO pressione ENTER");
            else
               entrada = JOptionPane.showInputDialog(componentePai, "Entre com a posicao do Obstculo " + i +
                                         "\nClique OK para confirmar\n" + "Ex.: 2,3 quer dizer [x=2, y=3]\n" +         "\nNO pressione ENTER");
   
            for (int j = 0; j < entrada.length(); j++)
            {
               tmp = entrada.charAt(j);
               if (tmp != ',')
               {
                  if (primeiro)
                     pNumero += tmp;
                  else
                     sNumero += tmp;
               }
               else
                  primeiro = false;
            }
            primeiro = true;

            pontoX = Integer.parseInt(pNumero);
            pontoY = Integer.parseInt(sNumero);
               
            // Verificando se o ponto passado  valido
            if (pontoX >= 0 && pontoX < getLimite() && pontoY >= 0 && pontoY < getLimite())
            {
               // Adicionando ponto vlido  lista de obstculos
               Point ptoInicio = new Point(pontoX, pontoY);
               if (chave == 1)
                  config.setPosicaoInicial(ptoInicio);
               else
                  config.setObstaculo(ptoInicio);
            }
            pNumero = "";
            sNumero = "";
         }
         catch(NullPointerException npe)
         {
            JOptionPane.showMessageDialog(componentePai, "Passo " + i + " cancelado." + 
                                          "\nIndo para o prximo passo", "Passo cancelado", 
                                          JOptionPane.WARNING_MESSAGE);
         }
      }
   }
}