(defrule sortear-movimentacao
   ?dir <- (direcao(face ?f))
   ?chave <- (sortear-outra-vez)
   =>
      (bind ?x (random))
      (bind ?y (mod ?x 4))
      (retract ?dir)
      (retract ?chave)

      (if (= ?y 1) then
         (store face norte)         
         (assert (direcao(face norte)))   
       else 
         (if (= ?y 2) then
            (store face sul)         
            (assert (direcao(face sul)))   
         else 
            (if (= ?y 3) then
               (store face leste)         
               (assert (direcao(face leste)))   
            else 
               (store face oeste)         
               (assert (direcao(face oeste)))   
            )
         )
      )
)

(defrule obstaculo
   (declare (salience 1))      
   (posicao-atual(px ?x)(py ?y))
   ?obs <- (obstaculo(sx ?x)(sy ?y))
   =>
   (store obs-x ?x)
   (store obs-y ?y)
   (assert(eliminado(ex ?x)(ey ?y)))
   (retract ?obs)
)

(defrule andar-norte
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (not(limites(norte ?y)(sul ?)(leste ?)(oeste ?)))
   ?dir <- (direcao(face norte))
   (not (sortear-outra-vez))
   (not(visitado(vx ?x)(vy =(+ ?y 1))))   
   =>
   (retract ?posicao)
   (bind ?novo-y (+ ?y 1))

   (store posicao-x ?x)
   (store posicao-y ?novo-y)

   (assert (posicao-atual(px ?x)(py ?novo-y)))
   (assert (sortear-outra-vez))
)

(defrule seguir-sul
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (not(limites(norte ?)(sul ?y)(leste ?)(oeste ?)))
   (direcao(face sul))
   (not (sortear-outra-vez))
   (not(visitado(vx ?x)(vy =(- ?y 1))))
   =>
   (retract ?posicao)
   (bind ?novo-y (- ?y 1))

   (store posicao-x ?x)
   (store posicao-y ?novo-y)

   (assert (posicao-atual(px ?x)(py ?novo-y)))
   (assert (sortear-outra-vez))
)

(defrule andar-leste
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (not(limites(norte ?)(sul ?)(leste ?x)(oeste ?)))
   (direcao(face leste))
   (not (sortear-outra-vez))
   (not(visitado(vx =(+ ?x 1))(vy ?y)))
   =>
   (retract ?posicao)
   (bind ?novo-x (+ ?x 1))

   (store posicao-x ?novo-x)
   (store posicao-y ?y)
   
   (assert (posicao-atual(px ?novo-x)(py ?y)))
   (assert (sortear-outra-vez))
)

(defrule andar-oeste
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (not(limites(norte ?)(sul ?)(leste ?)(oeste ?x)))
   (direcao(face oeste))
   (not (sortear-outra-vez))
   (not(visitado(vx =(- ?x 1))(vy ?y)))
   =>
   (bind ?novo-x (- ?x 1))
   (retract ?posicao)

   (store posicao-x ?novo-x)
   (store posicao-y ?y)
   
   (assert (posicao-atual(px ?novo-x)(py ?y)))
   (assert (sortear-outra-vez))
)

(defrule algum-limite
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (or(limites(norte ?y)(sul ?)(leste ?)(oeste ?))
      (limites(norte ?)(sul ?y)(leste ?)(oeste ?))
      (limites(norte ?)(sul ?)(leste ?x)(oeste ?))
      (limites(norte ?)(sul ?)(leste ?)(oeste ?x))
   )
   (not(sortear-outra-vez))
   ?cont <- (contador(valor ?z))
   =>
   (retract ?cont)
   (bind ?novo-z (+ ?z 1))
   (assert(contador(valor ?novo-z)))   

   (assert (sortear-outra-vez))
)

(defrule determinar-final
   (declare (salience 1))
   ?cont <- (contador(valor 10))
   =>
   (printout t "Fim da execucao" crlf)
   (halt)
)