(defrule existe-sujeira
   ?fato <- (posicao-atual(px ?x)(py ?y)) 
   ?sujeira <- (sujeira(sx ?x)(sy ?y))
   =>
   ;; Armazenando a visita atual
   (store vis-x ?x)
   (store vis-y ?y)

   (store limpo-x ?x)
   (store limpo-y ?y)
   
   (retract ?sujeira)
   (assert (visitado(vx ?x)(vy ?y)))
)

(defrule nao-existe-sujeira
   (posicao-atual(px ?x)(py ?y)) 
   (not(sujeira(sx ?x)(sy ?y)))
   =>
   ;; Armazenando a visita atual
   (store vis-x ?x)
   (store vis-y ?y)

   (assert (visitado(vx ?x)(vy ?y)))
)

(defrule seguir-norte
   (declare (salience -2))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (not(limites(norte ?y)(sul ?)(leste ?)(oeste ?)))
   (direcao(face norte))
   (not(visitado(vx ?x)(vy =(+ ?y 1))))
   =>
   (retract ?posicao)
   (bind ?novo-y (+ ?y 1))

   (store posicao-x ?x)
   (store posicao-y ?novo-y)
   
   (assert (posicao-atual(px ?x)(py ?novo-y)))
)

(defrule seguir-leste
   (declare (salience -2))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (not(limites(norte ?)(sul ?)(leste ?x)(oeste ?)))
   (not(visitado(vx =(+ ?x 1))(vy ?y)))
   (direcao(face leste))
   =>
   (bind ?novo-x (+ ?x 1))

   (store posicao-x ?novo-x)
   (store posicao-y ?y)

   (retract ?posicao)
   (assert (posicao-atual(px ?novo-x)(py ?y)))
)

(defrule seguir-sul
   (declare (salience -2))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (direcao(face sul))
   (not(limites(norte ?)(sul ?y)(leste ?)(oeste ?)))
   (not(visitado(vx ?x)(vy =(- ?y 1))))
   =>
   (bind ?novo-y (- ?y 1))

   (store posicao-x ?x)
   (store posicao-y ?novo-y)

   (retract ?posicao)
   (assert (posicao-atual(px ?x)(py ?novo-y)))
)

(defrule seguir-oeste
   (declare (salience -2))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (direcao(face oeste))
   (not(limites(norte ?)(sul ?)(leste ?)(oeste ?x)))
   (not(visitado(vx =(- ?x 1))(vy ?y)))
   =>
   (bind ?novo-x (- ?x 1))

   (store posicao-x ?novo-x)
   (store posicao-y ?y)

   (retract ?posicao)
   (assert (posicao-atual(px ?novo-x)(py ?y)))
)

(defrule virar-leste
   (declare (salience -2))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   ?face <- (direcao(face ?dir&~leste&~sul&~oeste))
   (or(limites(norte ?y)(sul ?)(leste ?)(oeste ?))
      (visitado(vx ?x)(vy =(+ ?y 1))))
   =>
   (store face leste)
   
   (retract ?face)
   (assert(direcao(face leste)))
)

(defrule virar-sul
   (declare (salience -2))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   ?face <- (direcao(face ?dir&~sul&~oeste&~norte))
   (or(limites(norte ?)(sul ?)(leste ?x)(oeste ?))
      (visitado(vx =(+ ?x 1))(vy ?y)))
   =>
   (store face sul)

   (assert(direcao(face sul)))
   (retract ?face)
)

(defrule virar-oeste
   (declare (salience -2))
   ?face <- (direcao(face ?dir&~oeste&~leste&~norte))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (or(limites(norte ?)(sul ?y)(leste ?)(oeste ?))
      (visitado(vx ?x)(vy =(- ?y 1))))
   =>
   (store face oeste)
   
   (assert(direcao(face oeste)))
   (retract ?face)
)

(defrule virar-norte
   (declare (salience -2))
   ?face <- (direcao(face ?dir&~norte&~leste&~sul))
   ?posicao <- (posicao-atual(px ?x)(py ?y))
   (or(limites(norte ?)(sul ?)(leste ?)(oeste ?x))
      (visitado(vx =(- ?x 1))(vy ?y)))
   =>
   (store face norte)

   (assert(direcao(face norte)))
   (retract ?face)
)

(defrule determina-final
   (limites(norte ?y)(sul ?)(leste ?x)(oeste ?))
   =>
   (bind ?x-int (integer(round(/ ?y 2))))
   (bind ?y-int (integer(round(/ ?y 2))))
   (assert (final (fx ?x-int)(fy ?y-int)))
)

(defrule stop-engine
   (declare(salience -1))
   (final (fx ?x)(fy ?y))
   (posicao-atual(px ?x)(py ?y))
   =>
   (printout t "Fim da execucao" crlf)
   (halt)
)

(defrule iniciar
   (declare(salience 10))
   ?inicio <- (iniciar)
   =>
   (retract ?inicio)
)
