;; Configura o estado inicial do sistema

(defrule configurar-estado-inicial
   (declare(salience 3))
   ?id <- (configurar-estado-inicial)
   (limites(norte ?n)(sul ?s)(leste ?l)(oeste ?o))
   =>
   (bind ?*visitados* (create$))
   (bind ?*limites* (create$ ?n ?s ?l ?o))
   (retract ?id)
)

(defrule obstaculo
   (declare(salience 2))
   (posicao-atual(px ?x)(py ?y))
   ?obs <- (obstaculo(sx ?x)(sy ?y))
   =>
   (store obs-x ?x)
   (store obs-y ?y)
   (assert(eliminado(ex ?x)(ey ?y)))
   (retract ?obs)
)

(deffunction sorteiar(?a ?b ?c ?d)
   (bind $?possiveis (create$ ?a ?b ?c ?d))
   (bind ?somatorio (+ ?a ?b ?c ?d))
   (bind ?sorteio 0)
   (if (eq ?somatorio 0) then
      (printout t "DELIBERACAO TERMINADA" crlf)
      (store retorno -1)
   else
      (while (eq ?sorteio 0)
         (bind ?aux (random))
         (bind ?aux (mod ?aux 4))
         (bind ?aux (+ ?aux 1))
         
         (if (eq (str-compare (nth$ ?aux $?possiveis)  "1") 0) then
            (store retorno ?aux)
            (bind ?sorteio 1)
         )
      )
   )
)

(defrule andar
   (declare(salience 1))
   ?pos <- (posicao-atual(px ?x)(py ?y))
   ?fc <- (direcao(face ?dir))
   =>
   (store vis-x ?x)
   (store vis-y ?y)
   (store verificar-possibilidades 1)
   (assert (visitado(vx ?x)(vy ?y)))
   (bind ?vis (str-cat ?x , ?y))
   (bind ?*visitados* (insert$ ?*visitados* 1 ?vis))

   (store verificar-possibilidades 2)
   (assert (verificar-possibilidades))
   (store verificar-possibilidades 1)
  
   (bind ?sorteio (fetch retorno))
   (if (eq ?sorteio -1) then
      (halt)
   else
      (retract ?pos)
      (retract ?fc)
      (if (eq ?sorteio 1) then
         (bind ?y (+ ?y 1))
         (store face norte)
         (store posicao-x ?x)
         (store posicao-y ?y)
         (assert (direcao(face norte)))
         (assert (posicao-atual(px ?x)(py ?y)))
      else
         (if (eq ?sorteio 2) then
            (bind ?y (- ?y 1))
            (store face sul)
            (store posicao-x ?x)
            (store posicao-y ?y)
            (assert (direcao(face sul)))
            (assert (posicao-atual(px ?x)(py ?y)))
         else
            (if (eq ?sorteio 3) then
               (bind ?x (+ ?x 1))
               (store face leste)
               (store posicao-x ?x)
               (store posicao-y ?y)
               (assert (direcao(face leste)))
               (assert (posicao-atual(px ?x)(py ?y)))
            else
               (bind ?x (- ?x 1))
               (store face oeste)
               (store posicao-x ?x)
               (store posicao-y ?y)
               (assert (direcao(face oeste)))
               (assert (posicao-atual(px ?x)(py ?y)))
            )
         )
      )
   )
)

(defrule limpar-verificacoes
   (declare(salience 3))
   ?fato1 <- (verificar-possibilidades)
   =>
   (retract ?fato1)
)

(deffunction presente(?tx ?ty)
   (bind ?xy (str-cat ?tx , ?ty))
   (bind ?var (member$ ?xy ?*visitados*))
   (if (eq ?var FALSE) then
      (return FALSE)
   else
      (return TRUE)
   )
)